(function() {
	/********************************
	 * Bluetooth
	 * Bluetoothの状態取得やON／OFF、
	 * シリアル通信が行える(Androidのみ)
	 ********************************/

	/*
	 * Bluetooth機能のサポート状況を取得
	 */
	bluetoothIsSupported = function() {
		applican.bluetooth.isSupported(bluetoothIsSupportedSuccess, bluetoothIsSupportedError);
	};

	/*
	 * Bluetooth機能のサポート状況取得に成功時のコールバック
	 * result true(対応)/false(非対応)
	 */
	bluetoothIsSupportedSuccess = function(result) {
		var dump = "サポート状況を取得しました\n";
		if (result === true) {
			dump += "result: Bluetooth機能をサポートしています";
		} else {
			dump += "result: Bluetooth機能をサポートしません";
		}
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * Bluetooth機能のサポート状況取得に失敗時のコールバック
	 */
	bluetoothIsSupportedError = function(error) {
		var dump = "サポート状況取得に失敗しました\n";
		dump    += "code: "    + error.code    + "\n";
		dump    += "message: " + error.message + "\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * Bluetooth機能の状態を取得
	 */
	bluetoothIsEnabled = function() {
		applican.bluetooth.isEnabled(bluetoothIsEnabledSuccess, bluetoothIsEnabledError);
	};

	/*
	 * Bluetooth機能の状態取得に成功時のコールバック
	 * result true(有効)/false(無効)
	 */
	bluetoothIsEnabledSuccess = function(result) {
		var dump = "Bluetooth機能の状態を取得しました\n";
		if (result === true) {
			dump += "result: Bluetooth機能が有効です";
		} else {
			dump += "result: Bluetooth機能が無効です";
		}
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * Bluetooth機能の状態取得に失敗時のコールバック
	 */
	bluetoothIsEnabledError = function(error) {
		var dump = "Bluetooth機能の状態取得に失敗しました\n";
		dump    += "code: "    + error.code    + "\n";
		dump    += "message: " + error.message + "\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * Bluetooth機能を有効に設定
	 */
	bluetoothEnable = function() {
		applican.bluetooth.enable(bluetoothEnableSuccess, bluetoothEnableError);
	};

	/*
	 * Bluetooth機能を有効に設定成功時のコールバック
	 */
	bluetoothEnableSuccess = function() {
		var dump = "Bluetooth機能を有効に設定しました\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};
	/*
	 * Bluetooth機能を有効に設定失敗時のコールバック
	 */
	bluetoothEnableError = function(error) {
		var dump = "Bluetooth機能を有効に設定失敗しました\n";
		dump    += "code: "    + error.code    + "\n";
		dump    += "message: " + error.message + "\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * Bluetooth機能を無効に設定
	 */
	bluetoothDisable = function() {
		applican.bluetooth.disable(bluetoothDisableSuccess, bluetoothDisableError);
	};

	/*
	 * Bluetooth機能を無効に設定成功時のコールバック
	 */
	bluetoothDisableSuccess = function() {
		var dump = "Bluetooth機能を無効に設定しました\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * Bluetooth機能を無効に設定失敗時のコールバック
	 */
	bluetoothDisableError = function(error) {
		var dump = "Bluetooth機能を無効に設定失敗しました\n";
		dump    += "code: "    + error.code    + "\n";
		dump    += "message: " + error.message + "\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * Bluetooth機器を検索
	 */
	bluetoothDiscover = function() {
		applican.bluetooth.discover(bluetoothDiscoverDiscovered, bluetoothDiscoverFinished, bluetoothDiscoverError);
	};

	/*
	 * Bluetooth機器を発見時のコールバック
	 */
	bluetoothDiscoverDiscovered = function(result) {
		var dump = "Bluetooth機器を発見しました\n";
		dump    += result.name + ", " + result.address + "\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * Bluetooth機器を検索完了時のコールバック
	 */
	bluetoothDiscoverFinished = function(result) {
		var listData = [];
		var dump = "Bluetooth機器の検索を完了しました\n";
		if (result !== null && result.length > 0) {
			var cnt = result.length;
			for (var i = 0; i < cnt; i++) {
				dump += result[i].name + ", " + result[i].address + "\n";
				listData[i] = {
					title      : result[i].name,
					subtitle   : result[i].address,
					valuetitle : "",
					picture    : "",
					value      : result[i].address
				};
			}
		}
		document.getElementById("dumpAreaBluetooth").value = dump;

		// リスト表示
		applican.list.show(applican.list.ListType.SUBTITLE, 'Address選択', listData,
			function(result) {
				document.getElementById("bluetoothAddressText").value = result;
			},
			function(error) {
				alert("error: " + error.code);
			}
		);
	};

	/*
	 * Bluetooth機器を検索失敗時のコールバック
	 */
	bluetoothDiscoverError = function(error) {
		var dump = "Bluetooth機器の検索を失敗しました\n";
		dump    += "code: "    + error.code    + "\n";
		dump    += "message: " + error.message + "\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * 自身を検索可能に設定
	 */
	bluetoothDiscoverableOn = function() {
		applican.bluetooth.discoverableOn(300, bluetoothDiscoverableOnSuccess, bluetoothDiscoverableOnError);
	};

	/*
	 * 自身を検索可能に設定成功時のコールバック
	 */
	bluetoothDiscoverableOnSuccess = function(result) {
		var dump = "自身を検索可能に設定成功しました\n";
		dump    += "result: " + result;
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * 自身を検索可能に設定失敗時のコールバック
	 */
	bluetoothDiscoverableOnError = function(error) {
		var dump = "自身を検索可能に設定失敗しました\n";
		dump    += "code: "    + error.code    + "\n";
		dump    += "message: " + error.message + "\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * 接続したことのあるデバイスを取得
	 */
	bluetoothGetBondedDevices = function() {
		applican.bluetooth.getBondedDevices(bluetoothGetBondedDevicesSuccess, bluetoothGetBondedDevicesError);
	};

	/*
	 * 接続したことのあるデバイスを取得成功時のコールバック
	 */
	bluetoothGetBondedDevicesSuccess = function(result) {
		var listData = [];
		var dump = "接続したことのあるデバイスを取得成功しました\n";
		if (result !== null && result.length > 0) {
			var cnt = result.length;
			for (var i = 0; i < cnt; i++) {
				dump += result[i].name + ", " + result[i].address + "\n";
				listData[i] = {
					title      : result[i].name,
					subtitle   : result[i].address,
					valuetitle : "",
					picture    : "",
					value      : result[i].address
				};
			}
		}
		document.getElementById("dumpAreaBluetooth").value = dump;

		// リスト表示
		applican.list.show(applican.list.ListType.SUBTITLE, 'Address選択', listData,
			function(result) {
				document.getElementById("bluetoothAddressText").value = result;
			},
			function(error) {
				alert("error: " + error.code);
			}
		);
	};

	/*
	 * 接続したことのあるデバイスを取得失敗時のコールバック
	 */
	bluetoothGetBondedDevicesError = function(error) {
		var dump = "接続したことのあるデバイスを取得失敗しました\n";
		dump    += "code: "    + error.code    + "\n";
		dump    += "message: " + error.message + "\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * 検索をキャンセル
	 */
	bluetoothCancelDiscovery = function() {
		applican.bluetooth.cancelDiscovery(bluetoothCancelDiscoverySuccess, bluetoothCancelDiscoveryError);
	};

	/*
	 * 検索をキャンセル成功時のコールバック
	 */
	bluetoothCancelDiscoverySuccess = function() {
		var dump = "検索をキャンセルしました\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * 検索をキャンセル失敗時のコールバック
	 */
	bluetoothCancelDiscoveryError = function(error) {
		var dump = "検索のキャンセルを失敗しました\n";
		dump    += "code: "    + error.code    + "\n";
		dump    += "message: " + error.message + "\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * 接続待ち状態にする(サーバ側)
	 */
	bluetoothWatchConnection = function() {
		applican.bluetooth.watchConnection(
			bluetoothServerOnOpen,
			bluetoothServerOnMessage,
			bluetoothServerOnClose,
			bluetoothServerOnError
		);
	};

	/*
	 * 接続完了時のコールバック
	 */
	bluetoothServerOnOpen = function() {
		var dump = "接続完了しました(サーバ)\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * メッセージ受信時のコールバック
	 * message : 受信したメッセージ(シリアル通信を定期的にポーリングして
	 *			 受信するため、長いデータは分割されて通知される場合がある)
	 */
	bluetoothServerOnMessage = function(message) {
		document.getElementById("bluetoothReceiveText").value = message;
	};

	/*
	 * 接断時のコールバック
	 */
	bluetoothServerOnClose = function() {
		var dump = "接断しました(サーバ)\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * 接続失敗時のコールバック
	 */
	bluetoothServerOnError = function(error) {
		var dump = "接続失敗しました(サーバ)\n";
		dump    += "code: "    + error.code    + "\n";
		dump    += "message: " + error.message + "\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * 接続する(クライアント側)
	 */
	bluetoothConnect = function() {
		var address = document.getElementById("bluetoothAddressText").value;
		applican.bluetooth.connect(
			address,
			bluetoothClientOnOpen,
			bluetoothClientOnMessage,
			bluetoothClientOnClose,
			bluetoothClientOnError
		);
	};

	/*
	 * 接続完了時のコールバック
	 */
	bluetoothClientOnOpen = function() {
		var dump = "接続完了しました(クライアント)\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * メッセージ受信時のコールバック
	 * message : 受信したメッセージ(シリアル通信を定期的にポーリングして
	 *			 受信するため、長いデータは分割されて通知される場合がある)
	 */
	bluetoothClientOnMessage = function(message) {
		document.getElementById("bluetoothReceiveText").value = message;
	};

	/*
	 * 接断時のコールバック
	 */
	bluetoothClientOnClose = function() {
		var dump = "接断しました(クライアント)\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * 接続失敗時のコールバック
	 */
	bluetoothClientOnError = function(error) {
		var dump = "接続失敗しました(クライアント)\n";
		dump    += "code: "    + error.code    + "\n";
		dump    += "message: " + error.message + "\n";
		document.getElementById("dumpAreaBluetooth").value = dump;
	};

	/*
	 * 接続中の相手へ文字列データを送信
	 * text : String 送信する文字列データを入力
	 */
	bluetoothSend = function() {
		applican.bluetooth.send(document.getElementById("bluetoothSendText").value);
	};

	/*
	 * Bluetooth通信を切断
	 */
	bluetoothDisconnect = function() {
		applican.bluetooth.disconnect();
	};

	/********************* イベント登録 *********************/
	document.addEventListener("deviceready", function() {
		// 「撮影してBase64で取得」ボタン押下処理
		document.getElementById("bluetoothIsSupportedBtn").addEventListener("touchend", bluetoothIsSupported, false);
		// 「有効になっているか」ボタン押下処理
		document.getElementById("bluetoothIsEnabledBtn").addEventListener("touchend", bluetoothIsEnabled, false);
		// 「有効にする」ボタン押下処理
		document.getElementById("bluetoothEnableBtn").addEventListener("touchend", bluetoothEnable, false);
		// 「無効にする」ボタン押下処理
		document.getElementById("bluetoothDisableBtn").addEventListener("touchend", bluetoothDisable, false);
		// 「自身を検索可能にする」ボタン押下処理
		document.getElementById("bluetoothDiscoverableOnBtn").addEventListener("touchend", bluetoothDiscoverableOn, false);
		// 「接続したことのあるデバイスを取得」ボタン押下処理
		document.getElementById("bluetoothGetBondedDevicesBtn").addEventListener("touchend", bluetoothGetBondedDevices, false);
		// 「Bluetooth機器を検索する」ボタン押下処理
		document.getElementById("bluetoothDiscoverBtn").addEventListener("touchend", bluetoothDiscover, false);
		// 「検索をキャンセルする」ボタン押下処理
		document.getElementById("bluetoothCancelDiscoveryBtn").addEventListener("touchend", bluetoothCancelDiscovery, false);
		// 「接続待ち状態にする(サーバ)」ボタン押下処理
		document.getElementById("bluetoothWatchConnectionBtn").addEventListener("touchend", bluetoothWatchConnection, false);
		// 「接続する(クライアント)」ボタン押下処理
		document.getElementById("bluetoothConnectBtn").addEventListener("touchend", bluetoothConnect, false);
		// 「送信する」ボタン押下処理
		document.getElementById("bluetoothSendBtn").addEventListener("touchend", bluetoothSend, false);
		// 「切断する」ボタン押下処理
		document.getElementById("bluetoothDisconnectBtn").addEventListener("touchend", bluetoothDisconnect, false);
	}, false);
})();
